import os
from cv2 import cv2
from algorithm.imageprocessing import create_salamander_image
import glob

min_good_match = 15
match_dist = 0.75
def match_single_image(input_image, match_image):
    bf = cv2.BFMatcher()
    input_salamander = create_salamander_image(input_image)
    match_salamander = create_salamander_image(match_image)

    match = bf.knnMatch(input_salamander.descriptors, match_salamander.descriptors, k=2)

    goodmatch = []
    for m, n in match:
        if m.distance < match_dist * n.distance:
            goodmatch.append([m])
    if len(goodmatch) > min_good_match:
        return True, len(goodmatch)
    return False, 0

def match_file_structure(input_image: str, match_directory: str):
    best_match = -1
    match_count = 0

    if os.path.isfile(input_image):
        for folder in os.listdir(match_directory):
            name_list = glob.glob(os.path.join(match_directory, folder, "*_str.*"))
            for filename in name_list:
                res, num_matches = match_single_image(input_image, filename)
                if res and num_matches > match_count:
                    match_count = num_matches
                    best_match = int(folder)
        return best_match
    else:
        return None
